
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>《Spring Data实战》——2.2　定义查询方法 / iVAN</title>

    <meta name="description" content="《Spring Data实战》——2.2　定义查询方法 2.2 定义查询方法 2.2.1 查找查询的策略 刚才看到的接口只声明了一个简单的查询方法.声明的方法会被基础设施探测到并进行解析,最终衍生出与存储相关的查询.但是,随着查询变得更加复杂,方法名会变得很冗长,显得很笨拙.对于更复杂的查询,依靠方法解析器所支持的关键字就不够了.因此,每种存储模块都提供了@Query注解,如示例2-8所示,它会接受存储相关的查询语言所支持的查询字符串,从而允许查询执行时进一步地定制化. 示例2-8 使用@Query注解手动定义查询 在这里,我们使用JPA作为例子并手">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">《Spring Data实战》——2.2　定义查询方法</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h3>2.2　定义查询方法</h3>
<p><strong>2.2.1　查找查询的策略</strong><br />
刚才看到的接口只声明了一个简单的查询方法。声明的方法会被基础设施探测到并进行解析，最终衍生出与存储相关的查询。但是，随着查询变得更加复杂，方法名会变得很冗长，显得很笨拙。对于更复杂的查询，依靠方法解析器所支持的关键字就不够了。因此，每种存储模块都提供了@Query注解，如示例2-8所示，它会接受存储相关的查询语言所支持的查询字符串，从而允许查询执行时进一步地定制化。</p>
<p>示例2-8　使用@Query注解手动定义查询</p>
<p><a href="https://yqfile.alicdn.com/963673ab9521cef67db5b4e79852b75cd6371e8b.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzk2MzY3M2FiOTUyMWNlZjY3ZGI1YjRlNzk4NTJiNzVjZDYzNzFlOGIucG5n.jpg"></a></p>
<p>在这里，我们使用JPA作为例子并手动定义了一个查询，当然这个查询原本也是可以通过衍生得到的。</p>
<p>查询甚至可以外部化配置到属性文件中（它位于MATA-INF目录下的$store-named- queries.properties文件中），在这里$store是用于替换jpa、mongo以及neo4j等的占位符。key值必须要遵循$domainType.$methodName这样的约定。因此，为了将我们已有的方法替换成外部配置的命名查询，key将会是Customer.findByEmailAddress。如果是使用已命名查询的话，那就不需要使用@Query注解了。</p>
<p><strong>2.2.2　衍生查询</strong><br />
如示例2-9所示，查询衍生机制内置于Spring Data Repository的基础设施之中，对基于Repository的实体来构建限制性的查询很有用处。我们会从方法中截取findBy、readBy以及getBy前缀并解析剩余的部分。一个基础的用法是，基于实体的属性来定义条件并使用And和Or将它们连接起来。</p>
<p>示例2-9　由方法名衍生查询</p>
<p><a href="https://yqfile.alicdn.com/5049e060a910a0cd1a19845f91eecf9863eeaa88.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzUwNDllMDYwYTkxMGEwY2QxYTE5ODQ1ZjkxZWVjZjk4NjNlZWFhODgucG5n.jpg"></a></p>
<p>解析的实际结果依赖于我们所使用的数据存储。这里也有一些需要注意的通用事项。表达式通常会是属性的遍历以及操作符，它们可以连接起来。如示例2-9所示的那样，可以通过And以及Or来连接属性表达式。除此之外，对于属性表达式来说，还可以支持各种操作符，如Between、LessThan、GreaterThan以及Like。因为不同的数据存储之间所支持的操作符有所区别，所以要看查阅每种存储对应的章节。</p>
<p>属性表达式<br />
属性表达式可以直接引用所管理实体的属性（如示例2-9中所示）。在查询创建的时候，我们已经确保所解析的属性就是领域类的属性。但是，依然可以遍历嵌套的属性来定义限制条件。在前面我们可以看到，Customer的Address中具有ZipCode属性。在这种情况下，如下这种方法名的查询将会创建x.address.zipCode这样的属性遍历。</p>
<p><a href="https://yqfile.alicdn.com/468880f11657ddaaf9c5cbdcce8d88db7dec61b8.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzQ2ODg4MGYxMTY1N2RkYWFmOWM1Y2JkY2NlOGQ4OGRiN2RlYzYxYjgucG5n.jpg"></a></p>
<p>这个方案的算法首先会将整体（AddressZipCode）作为一个属性进行解析并检查领域类中是否具有该名称的属性（第一个字母小写）。如果它存在的话，就会使用该属性。如果不存在，它会从右边开始将源信息按照“驼峰”命名的规则将其拆分为头部和尾部，然后尝试查找对应的属性（如AddressZip和Code）。如果按照这个头部信息找到了属性，那么我们将会使用尾部的信息继续往下构建树形的信息。因为示例中，第一次的分割并不匹配，我们将分割点继续左移（从“AddressZip、Code”移到“Address、ZipCode”）。</p>
<p>尽管这在大多数的场景下都是可行的，但是在一定情况下算法可能会选择错误的属性。假设Customer同时还有一个addressZip属性。那么我们的算法将会在第一次分割的时候就完成了匹配，这实际上选择了错误的属性，并且会导致最终的失败（因为addressZip类型可能并没有code属性）。为了解决这种模棱两可的问题，可以在方法名中使用下划线（_）来手动定义遍历点。所以，我们的方法名最终看起来是这样的：</p>
<p><a href="https://yqfile.alicdn.com/d55b69c5afa36e375752de680fab68f23b30b034.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2Q1NWI2OWM1YWZhMzZlMzc1NzUyZGU2ODBmYWI2OGYyM2IzMGIwMzQucG5n.jpg"></a></p>
<p><strong>2.2.3　分页和排序</strong><br />
如果查询所返回的结果数量增长很明显，那么分块访问数据就很有意义了。为了做到这一点，Spring Data提供了可与Repository一起使用的分页API。要读取哪一块数据的定义隐藏在Pageable接口及其实现PageRequest之中。得到的分页数据存放在Page中，它不仅包含了数据本身，还包含了元信息，这些信息包括它是不是第一页或最后一页以及一共有多少页等。为了计算这个元数据，除了初始的查询外，我们需要触发第二次查询。</p>
<p>借助于Repository，我们要使用分页功能时只需添加一个Pageable方法参数即可。不像其他的参数那样，这个参数是不与查询绑定的，用来限制返回的结果集。一种可选的方案就是返回Page类型，它会对结果集进行限制，但是需要另外一次查询来获取元信息（如可用元素的总数）。另一种可选的方案是使用List，它会避免额外的查询，但是不会提供元数据。如果不需要分页功能，只是想要排序，那么可以给方法签名上添加Sort参数，如示例2-10所示。</p>
<p>示例2-10　使用Pageable和Sort的查询方法</p>
<p><a href="https://yqfile.alicdn.com/210da52058c95bfd6aa7c33033910c3c2ab700d3.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzIxMGRhNTIwNThjOTViZmQ2YWE3YzMzMDMzOTEwYzNjMmFiNzAwZDMucG5n.jpg"></a></p>
<p>第一个方法允许传递Pageable实例到查询方法中，从而为静态定义的查询动态地增加分页功能。排序的功能可以通过Sort参数显式地传递给方法，也可以内嵌到PageRequest值对象中，如示例2-11所示。</p>
<p>示例2-11　使用Pageable和Sort</p>
<p><a href="https://yqfile.alicdn.com/74a960a8f14ce7e34ff5b049854d0b54b3ee5b16.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzc0YTk2MGE4ZjE0Y2U3ZTM0ZmY1YjA0OTg1NGQwYjU0YjNlZTViMTYucG5n.jpg"></a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 11:46:38</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%ad%98%e5%82%a8/" title="存储">存储</a>, <a href="https://www.iamivan.net/tag/https/" title="HTTPS">HTTPS</a>, <a href="https://www.iamivan.net/tag/%e7%ae%97%e6%b3%95/" title="算法">算法</a>, <a href="https://www.iamivan.net/tag/%e6%8e%92%e5%ba%8f/" title="排序">排序</a>, <a href="https://www.iamivan.net/tag/%e8%a1%a8%e8%be%be%e5%bc%8f/" title="表达式">表达式</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ad%98%e5%82%a8/" title="数据存储">数据存储</a>, <a href="https://www.iamivan.net/tag/screenshot/" title="ScreenShot">ScreenShot</a>, <a href="https://www.iamivan.net/tag/spring/" title="spring">spring</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>《Spring Data实战》——2.2　定义查询方法的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRwPBdp.html" rel="bookmark">《Spring Data实战》&mdash;&mdash;导读</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 数据访问领域在过去的7年间发生了重要的变化.过去30年间一直占据企业级数据存储和处理核心位置的关系型数据库已经不能再独领风骚了.在过去的7年间诞生了很多可选的数据存储形式,当然也有的面临着消亡,它们被使用到了带有关键任务的企业级应用程序之中.这些新的数据存储形式是为了解决特定的数据访问问题而设计的,使用关系型数据库通常无法高效地解决这些问题. 将关系型数据库推到拐点的一个问题就是扩展性(scale).试问,我们如何将几百甚至几千TB(terabyte)的数据存储到关系型数据库中?这个问题让			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pX0Galp.html" rel="bookmark">《Spring Data实战》&mdash;&mdash;第2章　Repository：便利的数据访问层   2&period;1快速入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第2章 Repository:便利的数据访问层 长期以来,实现应用程序的数据访问层一直是件繁琐的工作,因为我们经常需要编写大量的样板式代码,而且贫血(anemic)的领域类并没有按照真正面向对象或领域驱动方式来进行设计.因此Spring Data Repository抽象的目标就是大幅简化各种持久化存储持久层的实现.我们将会使用Spring Data JPA模块作为例子来讨论Repository抽象的基本理念.对于其他类型的存储,可以参考对应的例子. 2.1 快速入门 我们选取领域模型中的Cus			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8N8xBb.html" rel="bookmark">代码-spring data jpa 按条件分页查询问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 spring data jpa 按条件分页查询问题 自定义分页查询方法,代码: {&quot;content&quot;:[],&quot;totalPages&quot;:1,&quot;totalElements&quot;:6,&quot;last&quot;:true,&quot;number&quot;:1,&quot;size&quot;:10,&quot;numberOfElements&quot;:0,&quot;sort&quot;:null,&quot;first&quot;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9xVKkb.html" rel="bookmark">《Spring Data实战》&mdash;&mdash;2&period;3　定义Repository</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.3 定义Repository 到目前为止,我们看到了带有查询方法的Repository接口,这些查询有的是从方法名中衍生出来的,有的是手动声明的,这取决于Spring Data为实际存储类型所提供的使用方式.为了衍生出这些查询,我们必须扩展Spring Data的特定标识接口:Repository.除了查询以外,在你的Repository中还需要一些其他的功能:存储对象,删除对象,根据ID进行查找,返回所有存储的实体或按页对它们进行访问.通过Repository接口来暴露这些功能的最简单方式			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M12xQxp.html" rel="bookmark">《Spring Data实战》&mdash;&mdash;第1章　Spring Data项目   1&period;1为Spring开发人员提供的NoSQL数据访问功能</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第一部分 背景知识 第1章 Spring Data项目 Spring Data项目是在&quot;Spring One 2010开发者大会&quot;上创建的,该项目起源于当年早些时候Rod Johnson(SpringSource)和Emil Eifrem(Neo Technologies)共同参与的一场黑客会议.他们试图把Neo4j图形数据库整合到Spring框架中,并评估了各种不同的方式.这次会议最终为初始版本的Spring Data Neo4j模块奠定了基础,这个新的SpringSource项目旨			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJqLy7p.html" rel="bookmark">《Spring Data实战》&mdash;&mdash;2&period;4　IDE集成</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.4 IDE集成 在3.0版本中,Spring工具套件(Spring Tool Suite,STS)提供了与Spring Data Repository抽象进行集成的功能.STS为Spring Data所提供的核心支持是查找方法的查询衍生机制.它所能做到的第一件事就是在IDE中校验衍生查询方法的正确性,这样,不需要启动ApplicationContext就能立刻探测出方法名中引入的拼写错误. 如图2-1所示,IDE检测到Descrption是非法的,因为Product类中并没有这样的属性.为了			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z4W41rp.html" rel="bookmark">spring mvc &plus; spring data jpa 带条件的查询分页的问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 如题,springdatajpa用的是hibernate的实现.dao层继承了JpaRepository接口.初接触springdatajpa,求大神给小女子一个带条件的查询分页的demo.感激不尽! 解决方案 本帖最后由 shuzhen526 于 2013-04-01 14:16:52 编辑解决方案二:下载springside例子,继承了分页demo解决方案三:引用1楼lvzg_005的回复: 下载springside例子,继承了分页demo 我想用springdatajpa的接口中			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mye1W4M.html" rel="bookmark">《Spring Data实战》&mdash;&mdash;1&period;4　示例代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.4 示例代码 本书的示例代码可从GitHub上获取.它是一个Maven项目,包含每一章的模块.另外,还需要在电脑中安装Maven 3或者一个能导入Maven项目的IDE,比如Spring Tool Suite(STS).从下面的操作中可以看到,取得示例代码就如同复制版本库一样简单: 现在可以在命令行中执行Maven来构建代码: 这样Maven会解析依赖.编译和测试代码,执行测试,最终打包模块. 1.4.1 将源码导入到IDE STS/Eclipse 由于STS已经配备了m2eclipse插件			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVQe3Kp.html" rel="bookmark">《Spring Data实战》&mdash;&mdash;1&period;3　领域</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.3 领域 为了说明各种Spring Data模块的用法,我们会使用电子商务部门的示例领域(如图1-1所示).由于各种NoSQL数据存储通常具有特定的功能和适用场景,在个别章节会对领域的实现方式做出一些调整,甚至只有它的部分实现,这种做法不代表必须以一种特定的方法来实现领域,而是强调某些存储应该更适用于特定的应用场景. 在模型的核心,有客户(customer),包含客户的基本资料,如姓.名.电子邮箱地址.地址(一组包含街道.城市和国家的集合),还有由产品名称.描述.价格和其他属性构成的产品(p			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lpd7k3M.html" rel="bookmark" class="title">ontouchevent-android架子鼓怎么实现同时点击多个button同时响应操作的方法？</a>
					<div>
						问题描述 android架子鼓怎么实现同时点击多个button同时响应操作的方法? 本人很爱玩音乐 看到ios平台很多音乐的模拟软件 吉他的~贝斯的 鼓的~~但是android平台却相当不给力 这些软 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgR76b.html" rel="bookmark" class="title">&lbrack;剑指Offer&rsqb;5&period;二维数组中的查找</a>
					<div>
						题目 在一个二维数组中,每一行都按照从左到右递增的顺序排序,每一列都按照从上到下递增的顺序排序.请完成一个函数,输入这样的一个二维数组和一个整数,判断数组中是否含有该整数. 思路 [算法系列之三十三] ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgJA3b.html" rel="bookmark" class="title">如何在 jdbc 印出中文</a>
					<div>
						中文 1. 第一个方式: 以 Java Applet -&gt; socket -&gt; Java Application -&gt; database 为例: byte[] buff = new  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM694Nb.html" rel="bookmark" class="title">DOS命令全集&lpar;第三讲&rpar;</a>
					<div>
						(六)TREE--显示磁盘目录结构命令 1．功能:显示指定驱动器上所有目录路径和这些目录下的所有文件名. 2．类型:外部命令 3．格式:TREE[盘符:][/F][&gt;PRN] 4．使用说明: ( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1Mv0lWz.html" rel="bookmark" class="title">友情链接是把双刃剑 用与不用需要权衡</a>
					<div>
						国内的站长基本上都知道友情链接是个什么东西,也知道他的重要性,因为他能给给网站带来比较稳定的外链;所以但凡是在国内做站的站长没有一个不去做这块内容的,也包括我自己;在平时的链接交换工作中,通过与其他站 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLY42b.html" rel="bookmark" class="title">生成Excel高级报表</a>
					<div>
						前不久行里说要生成一个如下的Excel报表,试了很多种方法都不行,突然想到excel引用,宏,试写了下,发现效果不错. 各位可以参考此方法生成任意格式的Excel,可能很多人直接用程序来一行行的写,想 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj7g9nM.html" rel="bookmark" class="title">利用Thunk让C&plus;&plus;成员函数变回调函数</a>
					<div>
						Windows API经常需要回调函数,而在C++开发中面向对象当行其道,若能让C++类的成员函数成为回调函数,简直就是大善!但是C++成员函数都隐含了一个this指针用于指向当前的对象.要实现回调确 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7en5b.html" rel="bookmark" class="title">修改SQL数据库排序规则修改表栏位排序规则</a>
					<div>
						  修改SQL数据库排序规则修改表栏位排序规则 修改SQL数据库排序规则: 1.修改为单用户模式 2.然后关闭所有的查询窗口,修改Options的Collocation属性,如:Chinese_PRC ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLOeLvM.html" rel="bookmark" class="title">PHP中使用register</a>
					<div>
						  这篇文章主要介绍了PHP中使用register_shutdown_function函数截获fatal error示例,需要的朋友可以参考下 我们在做项目时,偶尔会因为不谨慎而出现fatal err ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4OeVp.html" rel="bookmark" class="title">php获取本周开始日期和结束日期的方法</a>
					<div>
						 这篇文章主要介绍了php获取本周开始日期和结束日期的方法,实例分析了php操作日期的技巧,具有一定参考借鉴价值,需要的朋友可以参考下     本文实例讲述了php获取本周开始日期和结束日期的方法.分 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKxGmp.html" rel="bookmark" class="title">PhotoShop液化滤镜塑造完美的脸型教程</a>
					<div>
						图/文:张东新(视觉盛艳设计) 图片提供:上海搜秀摄影 脸是人像摄影关注的中心.化妆师利用发饰和妆面修饰脸型,服装设计师利用服装和配饰美化脸型,摄影师利 用光影来塑造完美脸型,后期设计师则是利用Pho ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6e3qNb.html" rel="bookmark" class="title">Javascript浮点数保留两位小数点示例代码</a>
					<div>
						 本篇文章主要介绍了js浮点数保留两位小数点示例代码(四舍五入) 需要的朋友可以过来参考下,希望对大家有所帮助  代码如下: var changeTwoDecimal_f= function (flo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b242aqp.html" rel="bookmark" class="title">360浏览器炫图制作工具怎么安装</a>
					<div>
						  打开360浏览器,在浏览器的左侧有一些应用图标,如360云盘,右击一个图标,在显示的菜单中选中管理我的扩展. 进入360应用市场页面,在搜索框中输入炫图,点击搜应用按钮. 在搜索结果中有一个炫图制 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYRwKrp.html" rel="bookmark" class="title">Win7系统开机后自动宽带连接怎么设置</a>
					<div>
						  怎么设置一开机就可以自动宽带连接,省去手动点击宽带连接的繁琐步骤?那我们如何设置可以让它自动连接宽带呢?本教程中,安下小编将为大家介绍在win7中设置开机自动连接宽带的方法. Win7电脑开机后自 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7DnNM.html" rel="bookmark" class="title">烧饼修改器如何修改踢老板2</a>
					<div>
						  1.首先打开修改器,再进入游戏 2. 点击修改器浮标切换到修改器界面,在输入框中输入你想修改的游戏属性值(金币/血量/得分/力量-)的当前值; 3. 点击&quot;搜索&quot;按钮,搜索完成 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3kZmM.html" rel="bookmark" class="title">MySQL &CenterDot; 引擎特性 &CenterDot; InnoDB 崩溃恢复过程</a>
					<div>
						在前面两篇文章中,我们详细介绍了 InnoDB redo log 和 undo log 的相关知识,本文将介绍 InnoDB 在崩溃恢复时的主要流程. 本文代码分析基于 MySQL 5.7.7-RC  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6G13z.html" rel="bookmark" class="title">SpringAOP用注解开发操作日志，求大神指导。急！QQ794124093</a>
					<div>
						问题描述 SpringAOP用注解开发操作日志,求大神指导.急!QQ794124093 我用SSM框架,写这个日志,总是切不进去,也不知道是什么原因,找不到错误, 个人猜测是不是配置文件扫描类有问题. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2PdRqp.html" rel="bookmark" class="title">图片-c&num;  截图并传到数据库  但错误找不到文件</a>
					<div>
						问题描述 c# 截图并传到数据库 但错误找不到文件 1C 如下图程序 我运行到这里时可以截图 并且能够保存早debug中 但当我调试到吧图片转换为二进制流是就出错错误是找不到这个问件 但我去debug ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOlgv9b.html" rel="bookmark" class="title">&lbrack;Python&rsqb;Invalid mode &lpar;&amp;amp&semi;&num;39&semi;w&amp;amp&semi;&num;39&semi;&rpar; or filename&colon; &amp;amp&semi;&num;39&semi;d&colon;&bsol;x0bideo&amp;amp&semi;&num;39&semi;</a>
					<div>
						# -*- coding: utf-8 -*- import string import json import urllib2 import urllib import base64 import  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOlxP5b.html" rel="bookmark" class="title">&lbrack;翻译&rsqb; LTInfiniteScrollView</a>
					<div>
						LTInfiniteScrollView 效果: Usage - 使用 Create the scroll view by: 通过以下方式来创建出scroll view self.scrollView ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boRNO3z.html" rel="bookmark" class="title">东航也正式开启机上WiFi的商业测试</a>
					<div>
						在1万英尺的高空上网,或者在时速300公里的动车上享受视频连线,国内旅客可能很快就能体验到. &lt;每日经济新闻&gt;记者当天从中国北车获悉,上周末,该公司研制的新信息系统通过了专家评审,这意味着 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWlDlAp.html" rel="bookmark" class="title">我用程序操作文件的时候遇到这个问题，求帮助</a>
					<div>
						问题描述 我更新软件的时候会弹出一个&quot;accesstothepathisdenied&quot;(XP系统),再网上搜了很多,也没找到恶搞解决方法,这是代码stringUnfileName= ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGE4mEM.html" rel="bookmark" class="title">MS CRM 2011 插件&lpar;plugin&rpar;的快速开发 -- 创建模板</a>
					<div>
						如果你开发过很多MS CRM的插件的话,相信你一定会发现,如果每一次开发插件都从头做起的话,你会做很多重复性的工作.如果你发现你每天做着重复性的工作,你就要考虑怎样才能将重复降到最低,理想的情况就是只 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mgw3gOM.html" rel="bookmark" class="title">二三线城市将是未来地方社区的爆发点</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 最近国内颇具影响力的地方社区网站杭州19楼推出了面向全国的&quot;复制计划&quot;,意欲通过19楼的品牌资源及社区运维经验,吸引全国各地方的站长 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq739Oz.html" rel="bookmark" class="title">ide-关于IDE的界面设置，左侧栏显示不了文件夹</a>
					<div>
						问题描述 关于IDE的界面设置,左侧栏显示不了文件夹 我的IDE左侧怎么显示不了本地的文件夹 解决方案 http://zhidao.baidu.com/link?url=OoPgwi0inSowUDB ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mgw7w6M.html" rel="bookmark" class="title">三星Android全键盘Galaxy Pro官方图</a>
					<div>
						智能商务手机向来有着不错的市场收益和市场空间,所以众多手机厂商都在纷纷抢食这块巨大的蛋糕.除了黑莓.诺基亚和摩托罗拉等品牌推出面向商务用户的全键盘直板智能机型之外,三星也不甘落后于他人,其准备携手英国 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgEQ95z.html" rel="bookmark" class="title">JQuery validate插件验证用户注册信息&lowbar;jquery</a>
					<div>
						使用JQuery的validate插件做客户端验证非常方便,下面做一个使用validate插件验证用户注册信息的例子. 本实例使用的是1.5版本. 示例是在SSH下做的,代码如下: registe.j ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWZrJz.html" rel="bookmark" class="title">Android实现短信验证码自动拦截读取功能&lowbar;Android</a>
					<div>
						知识准备: 1.观察者模式的理解[文章稍后来到~~]  2.Android的Cursor使用[Android基础]  3.正则表达式使用[Java基础]  4.Handler使用[Android基础] ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0NDqJz.html" rel="bookmark" class="title">js 回车提交表单两种实现方法&lowbar;javascript技巧</a>
					<div>
						1.JavaScript 方法: 复制代码 代码如下: [javascript] &lt;script&gt; document.onkeydown=function(event){ e = even ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQWPZKp.html" rel="bookmark" class="title">威廉&CenterDot;张：我来百度不做技术</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 由百度顾问转任首席科学家,欲把百度打造成IT业&quot;黄埔军校&quot;,称&quot;比李彦宏更了解百度&quot; 第一次见到威廉·张的时候不 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
